/* A primitive client. NULL-MODEM cable connects COM1 to COM2
   Data run forward-backward */

#include <string>
#include "commconnect.h"
#include <iostream>
#include <signal.h>
using namespace std;


void handler (int signal_number) {
cout << "signal " << signal_number <<  endl;
    exit(1);
}

std::string RunningString;
int RunningStringLength;
std::string AccumulatingString1, AccumulatingString2 = "";


void someproc (TConnection* Sender) {
    usleep(1);
}

void DoRxCharProc (TCommunicationConnection* Sender, int Count, std::string& s, char* com) {
	TCommunicationConnection *cc = Sender;
	s += cc->Retrieve(Count);

	if (s.length() == RunningStringLength) {
	    cout << s.c_str() << endl;
	    if (s == RunningString)
	    cout << com << ": strings are equal" << endl; else
	    cout << com << ": error! incorrect data" << endl;

	    std::string tempstr = s;
	    AccumulatingString1 = AccumulatingString2 = "";
	    cc->Send(tempstr);
	}
}

void RxCharProcCom2(TCommunicationConnection* Sender, int Count, void* Dummy) {

	DoRxCharProc(Sender, Count, AccumulatingString1, "COM2");
	
}

void RxCharProcCom1(TCommunicationConnection* Sender, int Count, void* Dummy) {

	DoRxCharProc(Sender, Count, AccumulatingString2, "COM1");
	
}


int main()
{

	struct sigaction sa;
	memset (&sa, 0, sizeof(sa));
	sa.sa_handler = &handler;
	sigaction (SIGSEGV, &sa, NULL);
    sigaction (SIGTERM, &sa, NULL);
    sigaction (SIGHUP, &sa, NULL);
    sigaction (SIGILL, &sa, NULL);
    sigaction (SIGFPE, &sa, NULL);
    sigaction (SIGPIPE, &sa, NULL);
    sigaction (SIGALRM, &sa, NULL);
    sigaction (SIGCHLD, &sa, NULL);
    sigaction (SIGXCPU, &sa, NULL);
    sigaction (SIGVTALRM, &sa, NULL);
    sigaction (SIGABRT, &sa, NULL);
    sigaction (SIGTERM, &sa, NULL);

	TComm *com1, *com2 = 0;

try {
	com1 = new TComm;
#if defined(__QNX__)
	com1->DeviceName = "/dev/ser1";
#else
	com1->DeviceName = "/dev/ttyS1";
#endif
	com1->Baudrate = br19200;  // guaranteed fast baudrate for any OS
	cout <<((std::string)(com1->DeviceName)).c_str() << endl;
	com1->Active = true;
	com1->PurgeIn();
	com1->PurgeOut();
	com1->SetDTRState(true);
	com1->SetRTSState(true);
	com1->OnRxChar = RxCharProcCom1;
	com1->OnTxChar = someproc;

}
catch (TPortException &e) {
	cerr << "ERROR in object com1: " << e << endl;
	com1 = 0;
}

try {
	com2 = new TComm;
#if defined(__QNX__)
	com2->DeviceName = "/dev/ser2";
#else
	com2->DeviceName = "/dev/ttyS0";
#endif
	com2->Baudrate = br19200;
	cout <<((std::string)(com2->DeviceName)).c_str() << endl;
	com2->Active = true;
	com2->PurgeIn();
	com2->PurgeOut();
	com2->SetDTRState(true);
	com2->SetRTSState(true);
	com2->OnRxChar = RxCharProcCom2;
	com2->OnTxChar = someproc;
}
catch (TPortException &e) {
	cerr << "ERROR in object com2: " << e << endl;
	com2 = 0;
}

        if (com1 && com2) {
	  RunningString = "123456789012345678901234567890";// "" <-0xFF symbol
	  RunningStringLength = RunningString.length();

	  com1->Send(RunningString.c_str());

	  sleep(3);  // give some time to work

	  delete com2;
	  delete com1;
	}

	return 0;
}
