#ifndef __PROPERTY_H
#define __PROPERTY_H

/*
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <cstdlib>
*/


// READ_ONLY property template
template <typename proptype, typename propowner> class rproperty
{
    protected:
        typedef proptype (propowner::*getter)() ;
        propowner * m_owner;
        getter m_getter;
    public:
        operator proptype()
        {
            return (m_owner->*m_getter)();
        }
        void init(propowner * const owner, getter getmethod)
        {
            m_owner = owner;
            m_getter = getmethod;
        }
};

// READ_WRITE property template
template <typename proptype, typename propowner> class property
{
    protected:
        typedef proptype (propowner::*getter)() ;
        typedef void (propowner::*setter)(proptype);
        propowner * m_owner;
        getter m_getter;
        setter m_setter;
    public:
        operator proptype()
        {
            return (m_owner->*m_getter)();
        }
        void operator =(proptype data)
        {
            (m_owner->*m_setter)(data);
        }
        property() :
        m_owner(NULL),
            m_getter(NULL),
            m_setter(NULL)
        {
        }
        property(propowner * const owner, getter getmethod, setter setmethod) :
        m_owner(owner),
            m_getter(getmethod),
            m_setter(setmethod)
        {
        }
        void init(propowner * const owner, getter getmethod, setter setmethod)
        {
            m_owner = owner;
            m_getter = getmethod;
            m_setter = setmethod;
        }
};

#endif
